#ifndef STRING_UTILS_H_
#define STRING_UTILS_H_

#include "xdvi-config.h"

Boolean str_is_prefix(const char *, const char *);
Boolean str_is_suffix(const char *, const char *);
int length_of_int(int);
/* extern int length_of_long(long); */
int length_of_ulong(unsigned long);

typedef enum { USE_DVI_PATH, USE_CWD_PATH } expand_path_type_t;

/* remove `file:[//localhost/]' prefix from filename, and append `.dvi'
   extension if no extension is present */
char *filename_append_dvi(const char *fname);
/* prepend a path of type `type' (either CVW, or directory of dvi file)
   to `fname' */
char *expand_filename(const char *fname, expand_path_type_t type);

/* do both of the above */
char *expand_filename_append_dvi(const char *fname, expand_path_type_t type);

/* normalize `../' `./' `//' from path */
char *canonicalize_path(const char *path);

char *format_arg(const char *fmt, const char *arg, int *match);
char *escape_format_arg(const char *arg);
char *unquote_arg(char *fmt, const char *arg, int *match, int *len);
char *get_dir_component(const char *path);
char **get_space_separated_list(const char *source);
const char *find_format_str(const char *input, const char *fmt);
Boolean src_compare(const char *src, const char *target, const char *path, size_t path_len);
char *shell_escape_string(const char *str);

#endif /* STRING_UTILS_H_ */
